#ifndef intDec_hxx
#define intDec_hxx

//#include <CLAM/InPort.hxx>
//#include <CLAM/OutPort.hxx>
#include <CLAM/AudioInPort.hxx>
#include <CLAM/AudioOutPort.hxx>
#include <CLAM/Processing.hxx>
#include <CLAM/DataTypes.hxx>
#include <vector>
#include "poly_FIR_dec.hxx"
#include "poly_FIR_interp.hxx"

// Those two configuration types could be the ones you choose.
// Your own ones or any type already in CLAM.
#include <CLAM/Audio.hxx>

class intDec : public CLAM::Processing

{
	CLAM::AudioInPort mIn;
	CLAM::AudioOutPort mOut;
	poly_FIR_dec _myDecimator; 
	poly_FIR_interp _myInterpolator;
	std::vector<CLAM::TData> _firCoeffLowpass;
	
public:

	intDec(const Config& config = Config());
	const char* GetClassName() const;
	bool Do();
	bool Do(const CLAM::Audio& in, CLAM::Audio& out); //for the processing of data


};

#endif 

