#include <CLAM/Network.hxx>
#include <CLAM/JACKNetworkPlayer.hxx>
#include <CLAM/MultiChannelAudioFileReader.hxx>
#include "intDec.hxx"
int error(const std::string & msg)
{
	std::cerr << msg << std::endl;
	return -1;
}

int main(int argc, char ** argv)
{
	if (argc!=2) return error ("needs a filename.");

	CLAM::Network network;

	std::string filter = network.AddProcessing("intDec");
	std::string reader = network.AddProcessing("MultiChannelAudioFileReader");
	// Configure the reader
	CLAM::MultiChannelAudioFileReaderConfig cfg;
	cfg.SetSourceFile(argv[1]);
	if (!network.ConfigureProcessing(reader, cfg))
		 return error("Could not open the file");
	int length = ((CLAM::MultiChannelAudioFileReader &) network.GetProcessing(reader)).GetHeader().GetLength()/1000;

 	// Add two audio sinks and connect their inputs to the reader's output

	std::string sink = network.AddProcessing("AudioSink");
	std::string sink2 = network.AddProcessing("AudioSink");

	network.ConnectPorts(reader+".Channel #0", filter+".My Input"); //Till upp/nersamplare 

	network.ConnectPorts(filter+".My Output", sink+".AudioIn"); //Ena kanalen är processad
	network.ConnectPorts(reader+".Channel #1", sink2+".AudioIn"); //Andra kanalen är oprocessad

	// Set the audio backend to JACK
	network.SetPlayer(new CLAM::JACKNetworkPlayer);
	network.Start();
	sleep(length);
	network.Stop();
}
